<?php

namespace TVn7\UserBundle\Entity;

use Doctrine\ORM\EntityRepository;

/**
 * MembreRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class MembreRepository extends EntityRepository
{

    public function findAllPromo()
    {
        $qb = $this->createQueryBuilder('m');

        $qb->select('m.annee')
            ->groupBy('m.annee')
            ->orderBy('m.annee', 'DESC');

        return $qb->getQuery()->getResult();
    }

    public function findAllMembers() {
        $qb = $this->createQueryBuilder('m');

        $qb->leftJoin('m.postes', 'p')
            ->addSelect('p')
            ->orderBy('p.id', 'ASC')
            ->leftJoin('m.posteByDefault', 'pbd')
            ->addSelect('pbd')
            ->addOrderBy('m.nom', 'ASC')
            ->addOrderBy('m.prenom', 'ASC');

        return $qb->getQuery()->getResult();
    }

    public function findByPromo()
    {
        $qb = $this->createQueryBuilder('m');

        $qb->select('m.annee')
            ->groupBy('m.annee')
            ->orderBy('m.annee');

        return $qb->getQuery()->getResult();
    }

    public function findPromo($promo)
    {
        $qb = $this->createQueryBuilder('m');

        $qb->where('m.annee = :promo')
            ->leftJoin('m.postes', 'p')
            ->addSelect('p')
            ->orderBy('p.id', 'ASC')
            ->leftJoin('m.posteByDefault', 'pbd')
            ->addSelect('pbd')
            ->addOrderBy('m.nom', 'ASC')
            ->addOrderBy('m.prenom', 'ASC')
            ->setParameters(['promo' => $promo]);

        return $qb->getQuery()->getResult();
    }

    public function getPresident()
    {
        $qb = $this->createQueryBuilder('m');

        $qb->innerJoin('m.postes', 'p', 'WITH', 'p.name_canonical = :poste')
            ->setParameter("poste", "president")
            ->setMaxResults(1)
            ->orderBy('m.annee', 'DESC');

        return $qb->getQuery()->getSingleResult();
    }

    public function getTresoriers()
    {
        $qb = $this->createQueryBuilder('m');

        $qb->innerJoin('m.postes', 'p', 'WITH', 'p.name_canonical = :poste')
            ->setParameter("poste", "tresorier")
            ->orderBy('m.annee', 'DESC');

        return $qb->getQuery()->getResult();
    }

    public function getTresorier()
    {
        $qb = $this->createQueryBuilder('m');

        $qb->innerJoin('m.postes', 'p', 'WITH', 'p.name_canonical = :poste')
            ->setParameter("poste", "tresorier")
            ->setMaxResults(1)
            ->orderBy('m.annee', 'DESC');

        return $qb->getQuery()->getSingleResult();
    }

    public function findAllExpired($delay)
    {

        if(is_integer($delay)) {
            $dt = (new \DateTime())->sub(new \DateInterval('P'.$delay.'M'));
        } else {
            $dt = new \DateTime();
        }

        $qb = $this->createQueryBuilder('m');

        $qb->select('m')
                ->where('m.expiresAt <= :dt')
                ->setParameter('dt', $dt)
                ;

        return $qb->getQuery()->getResult();
    }

    public function getAllUsernames() {
        $qb = $this->createQueryBuilder('m');

        $qb->select('m.username');

        return array_map(function($m) {
            return $m['username'];
        }, $qb->getQuery()->getResult());
    }
}
